program ButtonBox;

uses gtk2, glib2;

{ Create a Button Box with the specified parameters }

function create_bbox (horizontal : boolean; title : pchar; spacing : gint;
                      child_w : gint; child_h : gint;
                      layout : gint) : PGtkWidget;
var
   frame, bbox, button : PGtkWidget;
begin
   frame := gtk_frame_new(title);

   if horizontal then
      bbox := gtk_hbutton_box_new()
   else
      bbox := gtk_vbutton_box_new();

   gtk_container_set_border_width(GTK_CONTAINER(bbox), 5);
   gtk_container_add(GTK_CONTAINER(frame), bbox);

   { Set the appearance of the Button Box }
   gtk_button_box_set_layout(GTK_BUTTON_BOX(bbox), layout);
   gtk_box_set_spacing(GTK_BUTTON_BOX(bbox), spacing);
   {gtk_button_box_set_child_size(GTK_BUTTON_BOX(bbox), child_w, child_h);}

   button := gtk_button_new_from_stock(GTK_STOCK_OK);
   gtk_container_add(GTK_CONTAINER(bbox), button);

   button := gtk_button_new_from_stock(GTK_STOCK_CANCEL);
   gtk_container_add(GTK_CONTAINER(bbox), button);

   button := gtk_button_new_from_stock(GTK_STOCK_HELP);
   gtk_container_add(GTK_CONTAINER (bbox), button);

   create_bbox := frame;
end;

var
   window, main_vbox, vbox, hbox, frame_horz, frame_vert : PGtkWidget;

begin
   { Initialise GTK }
   gtk_init(@argc, @argv);

   window := gtk_window_new(GTK_WINDOW_TOPLEVEL);
   gtk_window_set_title(GTK_WINDOW(window), 'Button Boxes');

   g_signal_connect(window, 'destroy',
                    G_CALLBACK(@gtk_main_quit), nil);

   gtk_container_set_border_width(GTK_CONTAINER(window), 10);

   main_vbox := gtk_vbox_new(false, 0);
   gtk_container_add(GTK_CONTAINER(window), main_vbox);

   frame_horz := gtk_frame_new('Horizontal Button Boxes');
   gtk_box_pack_start(GTK_BOX(main_vbox), frame_horz, true, true, 10);

   vbox := gtk_vbox_new(false, 0);
   gtk_container_set_border_width(GTK_CONTAINER(vbox), 10);
   gtk_container_add(GTK_CONTAINER(frame_horz), vbox);

   gtk_box_pack_start(GTK_BOX(vbox),
                      create_bbox(true, pchar('Spread (spacing 40)'), 40, 85,
                                  20, GTK_BUTTONBOX_SPREAD),
                      true, true, 0);

   gtk_box_pack_start(GTK_BOX(vbox),
                      create_bbox(true, pchar('Edge (spacing 30)'), 30, 85,
                                  20, GTK_BUTTONBOX_EDGE),
                      true, true, 5);

   gtk_box_pack_start(GTK_BOX(vbox),
                      create_bbox(true, pchar('Start (spacing 20)'), 20, 85,
                                  20, GTK_BUTTONBOX_START),
                      true, true, 5);

   gtk_box_pack_start(GTK_BOX(vbox),
                      create_bbox(true, pchar('End (spacing 10)'), 10, 85,
                                  20, GTK_BUTTONBOX_END),
                      true, true, 5);

   frame_vert := gtk_frame_new('Vertical Button Boxes');
   gtk_box_pack_start(GTK_BOX(main_vbox), frame_vert, true, true, 10);

   hbox := gtk_hbox_new(false, 0);
   gtk_container_set_border_width(GTK_CONTAINER(hbox), 10);
   gtk_container_add(GTK_CONTAINER(frame_vert), hbox);

   gtk_box_pack_start(GTK_BOX(hbox),
                      create_bbox(false, pchar('Spread (spacing 5)'), 5, 85,
                                  20, GTK_BUTTONBOX_SPREAD),
                      true, true, 0);

   gtk_box_pack_start(GTK_BOX(hbox),
                      create_bbox(false, pchar('Edge (spacing 30)'), 30, 85,
                                  20, GTK_BUTTONBOX_EDGE),
                      true, true, 5);

   gtk_box_pack_start(GTK_BOX(hbox),
                      create_bbox(false, pchar('Start (spacing 20)'), 20, 85,
                                  20, GTK_BUTTONBOX_START),
                      true, true, 5);

   gtk_box_pack_start(GTK_BOX(hbox),
                      create_bbox(false, pchar('End (spacing 20)'), 20, 85,
                                  20, GTK_BUTTONBOX_END),
                      true, true, 5);

   gtk_widget_show_all(window);

   { Enter the event loop }
   gtk_main();
end.

{*EOF*}

