{ Note for C version:

   Copyright (C) 1998 Cesar Miquel, Shawn T. Amundson, Mattias Grnlund
   Copyright (C) 2000 Tony Gale
  
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
  
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

program CalendarExample;

uses gtk2, {gdk2,} glib2;

{#include <stdio.h>
#include <string.h>}

const
   DEF_PAD : integer = 10;
   DEF_PAD_SMALL : integer = 5;  

type
   TCalendarData = record
                      flag_checkboxes : array [0..4] of PGtkWidget;
                      settings        : array [0..4] of gboolean;
                      font_dialog     : PGtkWidget;
                      window          : PGtkWidget;
                      prev2_sig       : PGtkWidget;
                      prev_sig        : PGtkWidget;
                      last_sig        : PGtkWidget;
                      month           : PGtkWidget;
                   end;               
   PCalendarData = ^TCalendarData;

{enum {
  calendar_show_header,
  calendar_show_days,
  calendar_month_change, 
  calendar_show_week,
  calendar_monday_first
};}

{ GtkCalendar }

procedure calendar_date_to_string (data     : PCalendarData; buffer : pchar; 
                                   buff_len : integer);
var
   date             : TGDate;
   year, month, day : guint;
begin
   gtk_calendar_get_date(GTK_CALENDAR(data^.window),
                         @year, @month, @day);
   g_date_set_dmy(@date, day, month + 1, year);
   g_date_strftime(buffer, buff_len - 1, '%x', @date);
end;

procedure calendar_set_signal_strings (sig_str : pchar; data : PCalendarData);
var
   prev_sig : pgchar;
begin
   prev_sig := gtk_label_get_text(GTK_LABEL(data^.prev_sig));
   writeln('after prev_sig');
   gtk_label_set_text(GTK_LABEL(data^.prev2_sig), prev_sig);

{  prev_sig = gtk_label_get_text(GTK_LABEL(data->last_sig));
  gtk_label_set_text(GTK_LABEL(data->prev_sig), prev_sig);
  gtk_label_set_text(GTK_LABEL(data->last_sig), sig_str);}
end;

procedure calendar_month_changed (widget : PGtkWidget;
                                  data : PCalendarData); cdecl;
var
   buffer : array [0..255] of char = 'month_changed: '#0;
   pbuf : pchar; 
begin
   calendar_date_to_string(data, @buffer[15], 256 - 15);
   calendar_set_signal_strings(buffer, data);
end;

{procedure calendar_day_selected (widget : PGtkWidget, data : PCalendarData);
  char buffer[256] = 'day_selected: ';

  calendar_date_to_string(data, buffer + 14, 256 - 14);
  calendar_set_signal_strings(buffer, data);
end;

procedure calendar_day_selected_double_click (widget : PGtkWidget,
                                              data : PCalendarData);
  char buffer[256] = 'day_selected_double_click: ';
  guint day;

  calendar_date_to_string(data, buffer + 27, 256 - 27);
  calendar_set_signal_strings(buffer, data);

  gtk_calendar_get_date(GTK_CALENDAR(data->window),
                        NULL, NULL, &day);

  if (GTK_CALENDAR(data->window)->marked_date[day - 1] == 0) 
    gtk_calendar_mark_day(GTK_CALENDAR(data->window), day);
  else 
    gtk_calendar_unmark_day(GTK_CALENDAR(data->window), day);
end;

procedure calendar_prev_month (widget : PGtkWidget, data : PCalendarData);
  char buffer[256] = 'prev_month: ';

  calendar_date_to_string(data, buffer + 12, 256 - 12);
  calendar_set_signal_strings(buffer, data);
end;

procedure calendar_next_month (widget : PGtkWidget, data : PCalendarData);
  char buffer[256] = 'next_month: ';

  calendar_date_to_string(data, buffer + 12, 256 - 12);
  calendar_set_signal_strings(buffer, data);
end;

procedure calendar_prev_year (widget : PGtkWidget, data : PCalendarData);
  char buffer[256] = 'prev_year: ';

  calendar_date_to_string(data, buffer + 11, 256 - 11);
  calendar_set_signal_strings(buffer, data);
end;

procedure calendar_next_year (widget : PGtkWidget, data : PCalendarData);
  char buffer[256] = 'next_year: ';

  calendar_date_to_string(data, buffer + 11, 256 - 11);
  calendar_set_signal_strings(buffer, data);
end;}

procedure calendar_set_flags (calendar : PCalendarData);
const
   option : array [0..4] of TGtkCalendarDisplayOptions =
   (GTK_CALENDAR_SHOW_HEADING,
    GTK_CALENDAR_SHOW_HEADING,
    GTK_CALENDAR_SHOW_HEADING,
    GTK_CALENDAR_SHOW_HEADING,
    GTK_CALENDAR_SHOW_HEADING);
var
   i       : integer;
   options : TGtkCalendarDisplayOptions = 0;
begin
   for i := 0 to 4 do  
      if calendar^.settings[i] then
         options := options or option[i];
   if calendar^.window <> nil then
      gtk_calendar_display_options(GTK_CALENDAR(calendar^.window), options);
end;

procedure calendar_toggle_flag (toggle : PGtkWidget;
                                calendar : PCalendarData); cdecl;
var
   i, j : integer;
begin
   j := 0;
   for i := 0 to 4 do
      if calendar^.flag_checkboxes[i] = toggle then
         j := i;

   calendar^.settings[j] := not calendar^.settings[j];
   calendar_set_flags(calendar);
end;

procedure calendar_font_selection_ok (button   : PGtkWidget;
                                      calendar : PCalendarData); cdecl;
var
   style     : PGtkStyle;
   font_name : pchar;
begin
   if calendar^.window <> nil then begin
      font_name := gtk_font_selection_dialog_get_font_name(GTK_FONT_SELECTION_DIALOG(calendar^.font_dialog));
      if font_name <> nil then begin 
{         style := gtk_rc_style_new();
      pango_font_description_free (style->font_desc);
      style->font_desc = pango_font_description_from_string(font_name);
      gtk_widget_modify_style(calendar->window, style);
      g_free(font_name);}
      end;
   end;
   gtk_widget_destroy(calendar^.font_dialog);
end;

procedure calendar_select_font (button : PGtkWidget;
                                calendar : PCalendarData); cdecl;
var
   window : PGtkWidget;
begin
   if calendar^.font_dialog = nil then begin
      window := gtk_font_selection_dialog_new('Font Selection Dialog');
      //g_return_if_fail(GTK_IS_FONT_SELECTION_DIALOG(window));
      calendar^.font_dialog := window;
    
      gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_MOUSE);
    
      g_signal_connect(window, 'destroy',
                       G_CALLBACK(@gtk_widget_destroyed),
                       @calendar^.font_dialog);
    
      g_signal_connect(GTK_FONT_SELECTION_DIALOG(window)^.ok_button,
                       'clicked', G_CALLBACK(@calendar_font_selection_ok),
                       calendar);
      g_signal_connect_swapped(GTK_FONT_SELECTION_DIALOG(window)^.cancel_button,
                               'clicked',
                               G_CALLBACK(@gtk_widget_destroy), 
                               calendar^.font_dialog);
   end;
   window := calendar^.font_dialog;
   if not GTK_WIDGET_VISIBLE(window) then
      gtk_widget_show(window)
   else
      gtk_widget_destroy(window);
end;

procedure create_calendar ();
var
   window, vbox, vbox2, vbox3, hbox, hbbox, calendar, toggle : PGtkWidget;
   button, frame, separator, a_label, bbox : PGtkWidget;
   calendar_data : TCalendarData;
   i : integer;

   flags : array [0..4] of pchar =
   ('Show Heading',
    'Show Day Names',
    'No Month Change',
    'Show Week Numbers',
    'Week Start Monday');
begin
   calendar_data.window := nil;
   calendar_data.font_dialog := nil;

   for i := 0 to 4 do
      calendar_data.settings[i] := false;

   window := gtk_window_new(GTK_WINDOW_TOPLEVEL);
   gtk_window_set_title(GTK_WINDOW(window), 'GtkCalendar Example');
   gtk_container_set_border_width(GTK_CONTAINER(window), 5);
   g_signal_connect(window, 'destroy',
                    G_CALLBACK(@gtk_main_quit), nil);
   g_signal_connect(window, 'delete-event',
                    G_CALLBACK(@gtk_false), nil);

   gtk_window_set_resizable(GTK_WINDOW(window), false);

   vbox := gtk_vbox_new(false, DEF_PAD);
   gtk_container_add(GTK_CONTAINER(window), vbox);

   { The top part of the window, Calendar, flags and fontsel. }

   hbox := gtk_hbox_new(false, DEF_PAD);
   gtk_box_pack_start(GTK_BOX(vbox), hbox, true, true, DEF_PAD);
   hbbox := gtk_hbutton_box_new();
   gtk_box_pack_start(GTK_BOX(hbox), hbbox, false, false, DEF_PAD);
   gtk_button_box_set_layout(GTK_BUTTON_BOX(hbbox), GTK_BUTTONBOX_SPREAD);
   gtk_box_set_spacing(GTK_BOX(hbbox), 5);

   { Calendar widget }
   frame := gtk_frame_new('Calendar');
   gtk_box_pack_start(GTK_BOX(hbbox), frame, false, true, DEF_PAD);
   calendar := gtk_calendar_new();
   calendar_data.window := calendar;
   calendar_set_flags(@calendar_data);
   gtk_calendar_mark_day(GTK_CALENDAR(calendar), 19);	
   gtk_container_add(GTK_CONTAINER(frame), calendar);
   g_signal_connect(calendar, 'month-changed', 
                    G_CALLBACK(@calendar_month_changed),
                    @calendar_data);
{  g_signal_connect(calendar, 'day_selected', 
                   G_CALLBACK(calendar_day_selected),
                   &calendar_data);
  g_signal_connect(calendar, 'day_selected_double_click', 
                   G_CALLBACK(calendar_day_selected_double_click),
                   &calendar_data);
  g_signal_connect(calendar, 'prev_month', 
                   G_CALLBACK(calendar_prev_month),
                   &calendar_data);
  g_signal_connect(calendar, 'next_month', 
                   G_CALLBACK(calendar_next_month),
                   &calendar_data);
  g_signal_connect(calendar, 'prev_year', 
                   G_CALLBACK(calendar_prev_year),
                   &calendar_data);
  g_signal_connect(calendar, 'next_year', 
                   G_CALLBACK(calendar_next_year),
                   &calendar_data);}

   separator := gtk_vseparator_new();
   gtk_box_pack_start(GTK_BOX(hbox), separator, false, true, 0);

   vbox2 := gtk_vbox_new(false, DEF_PAD);
   gtk_box_pack_start(GTK_BOX(hbox), vbox2, false, false, DEF_PAD);
  
   { Build the Right frame with the flags in } 
   
   frame := gtk_frame_new('Flags');
   gtk_box_pack_start(GTK_BOX(vbox2), frame, true, true, DEF_PAD);
   vbox3 := gtk_vbox_new(true, DEF_PAD_SMALL);
   gtk_container_add(GTK_CONTAINER(frame), vbox3);

   for i := 0 to 4 do begin
      toggle := gtk_check_button_new_with_label(flags[i]);
      g_signal_connect(toggle, 'toggled',
                       G_CALLBACK(@calendar_toggle_flag),
                       @calendar_data);
      gtk_box_pack_start(GTK_BOX(vbox3), toggle, true, true, 0);
      calendar_data.flag_checkboxes[i] := toggle;
   end;
   { Build the right font-button } 
   button := gtk_button_new_with_label('Font...');
   g_signal_connect(button, 'clicked',
                    G_CALLBACK(@calendar_select_font),
                    @calendar_data);
   gtk_box_pack_start(GTK_BOX(vbox2), button, false, false, 0);

   { Build the Signal-event part. }

   frame := gtk_frame_new('Signal events');
   gtk_box_pack_start(GTK_BOX(vbox), frame, true, true, DEF_PAD);
   
   vbox2 := gtk_vbox_new(true, DEF_PAD_SMALL);
   gtk_container_add(GTK_CONTAINER(frame), vbox2);
  
   hbox := gtk_hbox_new(false, 3);
   gtk_box_pack_start(GTK_BOX(vbox2), hbox, false, true, 0);
   a_label := gtk_label_new('Signal:'); 
   gtk_box_pack_start(GTK_BOX(hbox), a_label, false, true, 0);
   calendar_data.last_sig := gtk_label_new('');
   gtk_box_pack_start(GTK_BOX(hbox), calendar_data.last_sig, false, true, 0);

   hbox := gtk_hbox_new(false, 3);
   gtk_box_pack_start(GTK_BOX(vbox2), hbox, false, true, 0);
   a_label := gtk_label_new('Previous signal:');
   gtk_box_pack_start(GTK_BOX(hbox), a_label, false, true, 0);
   calendar_data.prev_sig := gtk_label_new('');
   gtk_box_pack_start(GTK_BOX(hbox), calendar_data.prev_sig, false, true, 0);

   hbox := gtk_hbox_new(false, 3);
   gtk_box_pack_start(GTK_BOX(vbox2), hbox, false, true, 0);
   a_label := gtk_label_new('Second previous signal:');
   gtk_box_pack_start(GTK_BOX(hbox), a_label, false, true, 0);
   calendar_data.prev2_sig := gtk_label_new('');
   gtk_box_pack_start(GTK_BOX(hbox), calendar_data.prev2_sig, false, true, 0);

   bbox := gtk_hbutton_box_new();
   gtk_box_pack_start(GTK_BOX(vbox), bbox, false, false, 0);
   gtk_button_box_set_layout(GTK_BUTTON_BOX(bbox), GTK_BUTTONBOX_END);

   button := gtk_button_new_with_label('Close');
   g_signal_connect(button, 'clicked', 
                    G_CALLBACK(@gtk_main_quit), nil); 
   gtk_container_add(GTK_CONTAINER(bbox), button);
   GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
   gtk_widget_grab_default(button);

   gtk_widget_show_all(window);
end;

begin
   gtk_init(@argc, @argv);

   create_calendar();

   gtk_main();
end.

{*EOF*}
