program EntryExample;

uses glib2, gdk2, gtk2;

procedure enter_callback (widget, entry : PGtkWidget); cdecl;
var
   entry_text : pgchar;
begin
   entry_text := gtk_entry_get_text(GTK_ENTRY(entry));
   writeln('Entry contents: ', entry_text);
end;

procedure entry_toggle_editable (checkbutton, entry: PGtkWidget); cdecl;
begin
   gtk_editable_set_editable(GTK_EDITABLE(entry),
                             gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbutton)));
end;

procedure entry_toggle_visibility (checkbutton, entry : PGtkWidget); cdecl;
begin
   gtk_entry_set_visibility(GTK_ENTRY(entry),
                            gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(checkbutton)));
end;

var
   window, vbox, hbox, entry, button, check : PGtkWidget;
   tmp_pos : integer;

begin
   gtk_init(@argc, @argv);

   { Create a new window }
   window := gtk_window_new(gtk_WINDOW_TOPLEVEL);
   gtk_widget_set_size_request(GTK_WIDGET(window), 200, 100);
   gtk_window_set_title(GTK_WINDOW(window), 'Gtk Entry');
   g_signal_connect(window, 'destroy',
                    G_CALLBACK(@gtk_main_quit), nil);
   g_signal_connect_swapped(window, 'delete-event',
                            G_CALLBACK(@gtk_widget_destroy), window);

   vbox := gtk_vbox_new(false, 0);
   gtk_container_add(GTK_CONTAINER(window), vbox);
   gtk_widget_show(vbox);

   entry := gtk_entry_new();
   gtk_entry_set_max_length(GTK_ENTRY(entry), 50);
   g_signal_connect(entry, 'activate',
                    G_CALLBACK(@enter_callback), entry);
   gtk_entry_set_text(GTK_ENTRY(entry), 'hello');
   tmp_pos := GTK_ENTRY(entry)^.text_length;
   gtk_editable_insert_text(GTK_EDITABLE(entry), ' world', -1, @tmp_pos);
   gtk_editable_select_region(GTK_EDITABLE(entry), 0, tmp_pos);
   gtk_box_pack_start(GTK_BOX(vbox), entry, true, true, 0);
   gtk_widget_show(entry);

   hbox := gtk_hbox_new(false, 0);
   gtk_container_add(GTK_CONTAINER(vbox), hbox);
   gtk_widget_show(hbox);

   check := gtk_check_button_new_with_label('Editable');
   gtk_box_pack_start(GTK_BOX(hbox), check, true, true, 0);
   g_signal_connect(check, 'toggled',
                    G_CALLBACK(@entry_toggle_editable), entry);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), true);
   gtk_widget_show(check);

   check := gtk_check_button_new_with_label('Visible');
   gtk_box_pack_start(GTK_BOX(hbox), check, true, true, 0);
   g_signal_connect(check, 'toggled',
                    G_CALLBACK(@entry_toggle_visibility), entry);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), true);
   gtk_widget_show(check);

   button := gtk_button_new_from_stock(GTK_STOCK_CLOSE);
   g_signal_connect_swapped(button, 'clicked',
                            G_CALLBACK(@gtk_main_quit), window);
   gtk_box_pack_start(GTK_BOX(vbox), button, true, true, 0);
   GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
   gtk_widget_grab_default(button);
   gtk_widget_show(button);

   gtk_widget_show(window);

   gtk_main();
end.

{*EOF*}
