program Filesel;

uses glib2, gdk2, gtk2;

{ Get the selected filename and print it to the console }

procedure file_ok_sel (w : PGtkWidget; fs : PGtkFileChooserDialog); cdecl;
begin
    writeln(gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(fs)));
end;

var
   filew : PGtkWidget;
   ok_button, cancel_button : PGtkWidget;

begin
   gtk_init(@argc, @argv);

   { Create a new file selection widget }
   filew := gtk_file_chooser_dialog_new('File selection', nil,
                                        GTK_FILE_CHOOSER_ACTION_SAVE,
                                        nil);
   ok_button := gtk_dialog_add_button(GTK_DIALOG(filew), GTK_STOCK_OK,
                                      GTK_RESPONSE_OK);
   cancel_button := gtk_dialog_add_button(GTK_DIALOG(filew), GTK_STOCK_CANCEL,
                                          GTK_RESPONSE_CANCEL);

   g_signal_connect(filew, 'destroy',
                    G_CALLBACK(@gtk_main_quit), nil);

   { Connect the ok_button to file_ok_sel function }
   g_signal_connect(ok_button, 'clicked',
                    G_CALLBACK(@file_ok_sel), filew);

   { Connect the cancel_button to destroy the widget }
   g_signal_connect_swapped(cancel_button, 'clicked',
                            G_CALLBACK(@gtk_widget_destroy), filew);

   { Lets set the filename, as if this were a save dialog, and we are
     giving a default filename }
   gtk_file_chooser_set_current_name(GTK_FILE_CHOOSER(filew),
                                     'penguin.png');

   gtk_widget_show(filew);
   gtk_main();
end.

{*EOF*}
