program fixedexample;

uses gtk2, glib2;

{ I'm going to be lazy and use some global variables to
  store the position of the widget within the fixed
  container }

var
   x : gint = 50;
   y : gint = 50;

{ This callback procedure moves the button to a new position
  in the Fixed container. }
   
procedure move_button (widget : PGtkWidget; fixed : PGtkWidget); cdecl;
begin
   x := (x + 30) mod 300;
   y := (y + 50) mod 300;
   gtk_fixed_move(GTK_FIXED(fixed), widget, x, y);
end;

var
   window, fixed, button : PGtkWidget;
   i : Integer;

begin
   { Initialise GTK }
   gtk_init(@argc, @argv);

   { Create a new window }
   window := gtk_window_new(GTK_WINDOW_TOPLEVEL);
   gtk_window_set_title(GTK_WINDOW(window), 'Fixed Container');

   { Here we connect the "destroy" event to a signal handler }
   g_signal_connect(window, 'destroy',
                    G_CALLBACK(@gtk_main_quit), nil);
   
   { Sets the border width of the window. }
   gtk_container_set_border_width(GTK_CONTAINER(window), 10);

   { Create a Fixed Container }
   fixed := gtk_fixed_new();
   gtk_container_add(GTK_CONTAINER(window), fixed);
   gtk_widget_show(fixed);

   for i := 1 to 3 do
   begin
      { Creates a new button with the label "Press me"}
      button := gtk_button_new_with_label('Press me');
      
      { When the button receives the "clicked" signal, it will call the
        function move_button() passing it the Fixed Container as its
        argument. }
      g_signal_connect(button, 'clicked',
                       G_CALLBACK(@move_button), fixed);

      { This packs the button into the fixed containers window. }
      gtk_fixed_put(GTK_FIXED(fixed), button, i * 50, i * 50);
      
      { The final step is to display this newly created widget. }
      gtk_widget_show(button);
   end;

   { Display the window }
   gtk_widget_show(window);

   { Enter the event loop }
   gtk_main();
end.

{*EOF*}
