program labelexample;

uses gtk2, glib2;

var
   window, hbox, vbox, frame, a_label : PGtkWidget;

begin
   { Initialise GTK }
   gtk_init(@argc, @argv);
   
   window := gtk_window_new(GTK_WINDOW_TOPLEVEL);
   g_signal_connect(window, 'destroy',
                    G_CALLBACK(@gtk_main_quit), nil);

   gtk_window_set_title(GTK_WINDOW(window), 'Label');
   vbox := gtk_vbox_new(false, 5);
   hbox := gtk_hbox_new(false, 5);
   gtk_container_add(GTK_CONTAINER(window), hbox);
   gtk_box_pack_start(GTK_BOX(hbox), vbox, false, false, 0);
   gtk_container_set_border_width(GTK_CONTAINER(window), 5);
   
   frame := gtk_frame_new('Normal Label');
   a_label := gtk_label_new('This is a Normal label');
   gtk_container_add(GTK_CONTAINER(frame), a_label);
   gtk_box_pack_start(GTK_BOX(vbox), frame, false, false, 0);

   frame := gtk_frame_new('Multi-line Label');
   a_label := gtk_label_new('This is a Multi-line label.'#10'Second line'#10 +
                            'Third line');
   gtk_container_add(GTK_CONTAINER(frame), a_label);
   gtk_box_pack_start(GTK_BOX(vbox), frame, false, false, 0);

   frame := gtk_frame_new('Left Justified Label');
   a_label := gtk_label_new('This is a Left-Justified'#10 +
                            'Multi-line label.'#10'Third      line'); 
   gtk_label_set_justify(GTK_LABEL(a_label), GTK_JUSTIFY_LEFT); 
   gtk_container_add(GTK_CONTAINER(frame), a_label);	      
   gtk_box_pack_start(GTK_BOX(vbox), frame, false, false, 0);

   frame := gtk_frame_new('Right Justified Label');
   a_label := gtk_label_new('This is a Right-Justified'#10'Multi-line label.'#10 +
                            'Fourth line, (j/k)'); 
   gtk_label_set_justify(GTK_LABEL(a_label), GTK_JUSTIFY_RIGHT);	
   gtk_container_add(GTK_CONTAINER(frame), a_label);		
   gtk_box_pack_start(GTK_BOX(vbox), frame, false, false, 0);
   
   vbox := gtk_vbox_new(false, 5);
   gtk_box_pack_start(GTK_BOX(hbox), vbox, false, false, 0);
   frame := gtk_frame_new('Line wrapped label');
   a_label := gtk_label_new('This is an example of a line-wrapped label.  It ' +
                            'should not be taking up the entire             ' +
                            'width allocated to it, but automatically ' +
                            'wraps the words to fit.  ' +
                            'The time has come, for all good men, to come to ' +
                            'the aid of their party.  ' +
                            'The sixth sheik''s six sheep''s sick.'#10 +
                            ' It supports multiple paragraphs correctly, ' +
                            'and  correctly   adds ' +
                            'many          extra spaces. ');
   gtk_label_set_line_wrap(GTK_LABEL(a_label), true); 
   gtk_container_add(GTK_CONTAINER(frame), a_label);
   gtk_box_pack_start(GTK_BOX(vbox), frame, false, false, 0);

   frame := gtk_frame_new('Filled, wrapped label');
   a_label := gtk_label_new('This is an example of a line-wrapped, filled label.  ' +
                            'It should be taking ' +
                            'up the entire              width allocated to it.  ' +
                            'Here is a sentence to prove ' +
                            'my point.  Here is another sentence. ' +
                            'Here comes the sun, do de do de do.'#10 +
                            '    This is a new paragraph.'#10 +
                            '    This is another newer, longer, better ' +
                            'paragraph.  It is coming to an end, ' +
                            'unfortunately.');
   gtk_label_set_justify(GTK_LABEL(a_label), GTK_JUSTIFY_FILL); 
   gtk_label_set_line_wrap(GTK_LABEL(a_label), true); 
   gtk_container_add(GTK_CONTAINER(frame), a_label);
   gtk_box_pack_start(GTK_BOX(vbox), frame, false, false, 0);

   frame := gtk_frame_new('Underlined label');
   a_label := gtk_label_new('This label is underlined!'#10 +
                            'This one is underlined in quite a funky fashion');
   gtk_label_set_justify(GTK_LABEL(a_label), GTK_JUSTIFY_LEFT); 
   gtk_label_set_pattern(GTK_LABEL(a_label),
                         '_________________________ _ _________ _ ______     __ _______ ___'); 
   gtk_container_add(GTK_CONTAINER(frame), a_label);
   gtk_box_pack_start(GTK_BOX(vbox), frame, false, false, 0);
   
   gtk_widget_show_all(window);

   gtk_main();
end.

{*EOF*}
