program NotebookExample;

uses glib2, gdk2, gtk2;

function itos (I : Longint) : String;
{ converts longint type to a String }
var
   S : String[15];
begin
   Str(I, S);
   itos := S;
end;

{ This function rotates the position of the tabs }

procedure rotate_book (button : PGtkButton; notebook : PGtkNotebook); cdecl;
begin
   //gtk_notebook_set_tab_pos(notebook, TGtkPositionType((tab_pos(notebook^) + 1) mod 4));
   gtk_notebook_set_tab_pos(notebook, TGtkPositionType((tab_pos(notebook^) + 1) mod 4));
end;

{ Add/Remove the page tabs and the borders }

procedure tabsborder_book (button : PGtkButton; notebook : PGtkNotebook); cdecl;
var
   tval, bval : gboolean;
begin
   if not gtk_notebook_get_show_tabs(notebook) then
      tval := true
   else
      tval := false;
   if not gtk_notebook_get_show_border(notebook) then
      bval := true
   else
      bval := false;

   gtk_notebook_set_show_tabs(notebook, tval);
   gtk_notebook_set_show_border(notebook, bval);
end;

{ Remove a page from the notebook }

procedure remove_book (button : PGtkButton; notebook : PGtkNotebook); cdecl;
var
   page : gint ;
begin
   page := gtk_notebook_get_current_page(notebook);
   gtk_notebook_remove_page(notebook, page);
   { Need to refresh the widget -- This forces the widget to redraw itself. }
   gtk_widget_queue_draw(GTK_WIDGET(notebook));
end;

function delete (widget : PGtkWidget; event: pGdkEvent;
                 data: gpointer) : gboolean; cdecl;
begin
   gtk_main_quit();
   delete := false;
end;

var
   window, button, table, notebook, frame, a_label, checkbutton : PGtkWidget; 
   i : integer;        
   bufferf, bufferl : string[33];

begin
   gtk_init(@argc, @argv);

   window := gtk_window_new(GTK_WINDOW_TOPLEVEL);

   g_signal_connect(window, 'delete-event',
                    G_CALLBACK(@delete), NIL);

   gtk_container_set_border_width(GTK_CONTAINER(window), 10);

   table := gtk_table_new(2, 6, false);
   gtk_container_add(GTK_CONTAINER(window), table);

   { Create a new notebook, place the position of the tabs }
   notebook := gtk_notebook_new();
   gtk_notebook_set_tab_pos(GTK_NOTEBOOK(notebook), GTK_POS_TOP);
   gtk_table_attach_defaults(GTK_TABLE(table), notebook, 0, 6, 0, 1);
   gtk_widget_show(notebook);

   { Let's append a bunch of pages to the notebook }
   for i := 1 to 5 do
   begin
      bufferf := 'Append Frame ' + itos(i) + #0;  //!!!
      bufferl := 'Page ' + itos(i) + #0;

      frame := gtk_frame_new(pchar(@bufferf[1]));
      gtk_container_set_border_width(GTK_CONTAINER(frame), 10);
      gtk_widget_set_size_request(frame, 100, 75);
      gtk_widget_show(frame);

      a_label := gtk_label_new(pchar(@bufferf[1]));
      gtk_container_add(pGTKCONTAINER (frame), a_label);
      gtk_widget_show(a_label);

      a_label := gtk_label_new(pchar(@bufferl[1]));
      gtk_notebook_append_page(GTK_NOTEBOOK(notebook), frame, a_label);
   end;

   { Now let's add a page to a specific spot }
   checkbutton := gtk_check_button_new_with_label('Check me please!');
   gtk_widget_set_size_request(checkbutton, 100, 75);
   gtk_widget_show(checkbutton);

   a_label := gtk_label_new('Add page');
   gtk_notebook_insert_page(GTK_NOTEBOOK(notebook), checkbutton, a_label, 2);

   { Now finally let's prepend pages to the notebook }
   for i := 1 to 5 do
   begin
      bufferf := 'Prepend Frame ' + itos(i) + #0;  //!!!
      bufferl := 'PPage ' + itos(i) + #0;

      frame := gtk_frame_new(pchar(@bufferf[1]));
      gtk_container_set_border_width(GTK_CONTAINER(frame), 10);
      gtk_widget_set_size_request(frame, 100, 75);
      gtk_widget_show(frame);

      a_label := gtk_label_new(pchar(@bufferf[1]));
      gtk_container_add(GTK_CONTAINER(frame), a_label);
      gtk_widget_show(a_label);
      
      a_label := gtk_label_new(pchar(@bufferl[1]));
      gtk_notebook_prepend_page(GTK_NOTEBOOK(notebook), frame, a_label);
   end;

   { Set what page to start at (page 4) }
   gtk_notebook_set_current_page(GTK_NOTEBOOK(notebook), 3);

   { Create a bunch of buttons }
   button := gtk_button_new_with_label('close');
   g_signal_connect_swapped(button, 'clicked',
                            G_CALLBACK(@delete), nil);
   gtk_table_attach_defaults(GTK_TABLE(table), button, 0, 1, 1, 2);
   gtk_widget_show(button);

   button := gtk_button_new_with_label('next page');
   g_signal_connect_swapped(button, 'clicked',
                            G_CALLBACK(@gtk_notebook_next_page),
                            notebook);
   gtk_table_attach_defaults(GTK_TABLE(table), button, 1, 2, 1, 2);
   gtk_widget_show(button);

   button := gtk_button_new_with_label('prev page');
   g_signal_connect_swapped(button, 'clicked',
                            G_CALLBACK(@gtk_notebook_prev_page),
                            notebook);
   gtk_table_attach_defaults(GTK_TABLE(table), button, 2, 3, 1, 2);
   gtk_widget_show(button);

   button := gtk_button_new_with_label('tab position');
   g_signal_connect(button, 'clicked',
                    G_CALLBACK(@rotate_book), notebook);
   gtk_table_attach_defaults(GTK_TABLE(table), button, 3, 4, 1, 2);
   gtk_widget_show(button);

   button := gtk_button_new_with_label('tabs/border on/off');
   g_signal_connect(button, 'clicked',
                    G_CALLBACK(@tabsborder_book), notebook);
   gtk_table_attach_defaults(GTK_TABLE(table), button, 4, 5, 1, 2);
   gtk_widget_show(button);

   button := gtk_button_new_with_label('remove page');
   g_signal_connect(button, 'clicked',
                    G_CALLBACK(@remove_book), notebook);
   gtk_table_attach_defaults(GTK_TABLE(table), button, 5, 6, 1, 2);
   gtk_widget_show(button);

   gtk_widget_show(table);
   gtk_widget_show(window);

   gtk_main ();
end.

{*EOF*}
