program PixmapExample;

uses glib2, gdk2, gtk2;

{ XPM data of Open-File icon }

const
  xpm_data : array [0..19] of pchar = 
   ('16 16 3 1',                    
    '       c None',
    '.      c #000000000000',
    'X      c #FFFFFFFFFFFF',
    '                ',
    '   ......       ',
    '   .XXX.X.      ',
    '   .XXX.XX.     ',
    '   .XXX.XXX.    ',
    '   .XXX.....    ',
    '   .XXXXXXX.    ',
    '   .XXXXXXX.    ',
    '   .XXXXXXX.    ',
    '   .XXXXXXX.    ',
    '   .XXXXXXX.    ',
    '   .XXXXXXX.    ',
    '   .XXXXXXX.    ',
    '   .........    ',
    '                ',
    '                ');

{ When invoked (via signal delete_event), terminates the application. }

function close_application (widget : PGtkWidget; event: PGdkEvent;
                            data : pgpointer) : boolean; cdecl;
begin
   gtk_main_quit();
   close_application := false;
end;

{ Is invoked when the button is clicked.  It just prints a message. }

procedure button_clicked (widget : PGtkWidget; data: gpointer); cdecl;
begin
   writeln('button clicked');
end;

var
   window, image, button : PGtkWidget;
   pixmap : PGdkPixmap;
   mask : PGdkBitmap;
   style : PGtkStyle;

begin
   { Create the main window, and attach delete_event signal to terminate
     the application }
   gtk_init( @argc, @argv );
   window := gtk_window_new(GTK_WINDOW_TOPLEVEL);
   g_signal_connect(G_OBJECT (window), 'delete_event',
                    G_CALLBACK(@close_application), nil);
   gtk_container_set_border_width(GTK_CONTAINER (window), 10);
   gtk_widget_show(window);

   { Now for the pixmap from gdk }
   style := gtk_widget_get_style(window);
   pixmap := gdk_pixmap_create_from_xpm_d(window^.window, mask,
                                          @style^.bg[GTK_STATE_NORMAL],
                                          ppgchar(xpm_data));

   { An image widget to contain the pixmap }
   image := gtk_image_new_from_pixmap(pixmap, mask);
   gtk_widget_show(image);

   { A button to contain the pixmap }
   button := gtk_button_new();
   gtk_container_add(GTK_CONTAINER(button), image);
   gtk_container_add(GTK_CONTAINER(window), button);
   gtk_widget_show(button);

   g_signal_connect(G_OBJECT(button), 'clicked',
                    G_CALLBACK(@button_clicked), nil);

   { Show the window }
   gtk_main();
end.

{*EOF*}
