program radiobuttons;

uses gtk2, gdk2, glib2;

function close_application (widget : PGtkWidget; event : PGdkEvent;
                            data : gpointer) : boolean; cdecl;
begin
   gtk_main_quit();
   close_application := false;
end;

var
   window, box1, box2, button, separator : PGtkWidget;
   group : PGSList;

begin
   gtk_init(@argc,@argv);

   window := gtk_window_new(GTK_WINDOW_TOPLEVEL);

   g_signal_connect(window, 'delete-event',
                    G_CALLBACK(@close_application), nil);
   
   gtk_window_set_title(GTK_WINDOW(window), 'radio buttons');
   gtk_container_set_border_width(GTK_CONTAINER(window), 0);

   box1 := gtk_vbox_new(false, 0);
   gtk_container_add(GTK_CONTAINER(window), box1);
   gtk_widget_show(box1);
   
   box2 := gtk_vbox_new(false, 10);
   gtk_container_set_border_width(GTK_CONTAINER(box2), 10);
   gtk_box_pack_start(GTK_BOX(box1), box2, true, true, 0);
   gtk_widget_show(box2);
   
   button := gtk_radio_button_new_with_label(nil, 'button1');
   gtk_box_pack_start(GTK_BOX(box2), button, true, true, 0);
   gtk_widget_show(button);

   group := gtk_radio_button_get_group(GTK_RADIO_BUTTON(button));
   button := gtk_radio_button_new_with_label(group, 'button2');
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), true);
   gtk_box_pack_start(GTK_BOX(box2), button, true, true, 0);
   gtk_widget_show(button);
   
   button := gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(button),
                                                         'button3');
   gtk_box_pack_start(GTK_BOX(box2), button, true, true, 0);
   gtk_widget_show(button);
   
   separator := gtk_hseparator_new;
   gtk_box_pack_start(GTK_BOX(box1), separator, false, true, 0);
   gtk_widget_show(separator);
   
   box2 := gtk_vbox_new(false, 10);
   gtk_container_set_border_width(GTK_CONTAINER(box2), 10);
   gtk_box_pack_start(GTK_BOX(box1), box2, false, true, 0);
   gtk_widget_show(box2);
   
   button := gtk_button_new_with_label('close');
   g_signal_connect_swapped(button, 'clicked',
                            G_CALLBACK(@close_application), window);
   gtk_box_pack_start(GTK_BOX(box2), button, true, true, 0);
   GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
   gtk_widget_grab_default(button);
   gtk_widget_show(button);
   gtk_widget_show(window);
   
   gtk_main();
end.

{*EOF*}
