program Scrolledwin;

uses gtk2, glib2, sysutils;

procedure destroy (widget : PGtkWidget; data : gpointer); cdecl;
begin
   gtk_main_quit();
end;

var
   window, scrolled_window, table, button : PGtkWidget;
   i, j					  : Integer;
   label_str				  : String; 
   l_str_as_char_ptr			  : pChar;  

begin
   gtk_init(@argc, @argv);
   
   { Create a new dialog window for the scrolled window to be packed into }
   window := gtk_dialog_new();
   g_signal_connect(window, 'destroy',
                    G_CALLBACK(@destroy), nil);
   gtk_window_set_title(GTK_WINDOW(window), 'GtkScrolledWindow example');
   gtk_container_set_border_width(GTK_CONTAINER(window), 0);
   gtk_widget_set_size_request(window, 300, 300);

   { Create a new scrolled window. }
   scrolled_window := gtk_scrolled_window_new(nil, nil);

   gtk_container_set_border_width(GTK_CONTAINER(scrolled_window), 10);

   { The policy is one of GTK_POLICY_AUTOMATIC, or GTK_POLICY_ALWAYS.
     GTK_POLICY_AUTOMATIC will automatically decide whether you need
     scrollbars, whereas GTK_POLICY_ALWAYS will always leave the scrollbars
     there. The first one is the horizontal scrollbar, the second,
     the vertical.}
   gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_window),
				  GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
   { The dialog window is created with a vbox packed into it. }
   gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)^.vbox), scrolled_window,
                      true, true, 0);
   gtk_widget_show(scrolled_window);

   { Create a table of 10 by 10 squares. }
   table := gtk_table_new(10, 10, false);

   { Set the spacing to 10 on x and 10 on y }
   gtk_table_set_row_spacings(GTK_TABLE(table), 10);
   gtk_table_set_col_spacings(GTK_TABLE(table), 10);

   { Pack the table into the scrolled window }
   gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrolled_window),
                                         table);
   gtk_widget_show(table);

   { This simply creates a grid of toggle buttons on the table
     to demonstrate the scrolled window.}
   for i := 1 to 10 do
   begin
      for j := 1 to 10 do
      begin
	 label_str := 'Button (' + IntToStr(i) + ',' + IntToStr(j) + ')' + #10 + ' ';  //!!!
	 l_str_as_char_ptr := StrAlloc(Length(label_str) + 1); 
	 StrPCopy(l_str_as_char_ptr, label_str);
	 button := gtk_toggle_button_new_with_label(l_str_as_char_ptr); 
	 gtk_table_attach_defaults(GTK_TABLE(table), button,
                                   i, i + 1, j, j + 1);
	 gtk_widget_show(button);
      end;
   end;

   { Add a "close" button to the bottom of the dialog }
   button := gtk_button_new_with_label('close');
   g_signal_connect_swapped(button, 'clicked',
                            G_CALLBACK(@gtk_widget_destroy), window);

   { This makes it so the button is the default.}
   GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
   gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)^.action_area), button,
                      true, true, 0);

   { This grabs this button to be the default button. Simply hitting
     the "Enter" key will cause this button to activate. }
   gtk_widget_grab_default(button);
   gtk_widget_show(button);

   gtk_widget_show(window);

   gtk_main();
end.

{*EOF*}
