program Spinbutton;

uses glib2, gtk2;

const
    a : gint = 1;
    b : gint = 2;

var
   spinner1 : PGtkWidget;

function GPOINTER_TO_INT (data : pgint) : gint;
begin
    GPOINTER_TO_INT := data^;
end;

procedure toggle_snap (widget : PGtkWidget; spin : PGtkSpinButton); cdecl;
begin
   gtk_spin_button_set_snap_to_ticks(spin, gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
end;

procedure toggle_numeric (widget : PGtkWidget; spin : PGtkSpinButton); cdecl;
begin
   gtk_spin_button_set_numeric(spin, gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
end;

procedure change_digits (widget : PGtkWidget; spin : PGtkSpinButton); cdecl;
begin
   gtk_spin_button_set_digits(GTK_SPIN_BUTTON(spinner1),
                              gtk_spin_button_get_value_as_int(spin));
end;

procedure get_value (widget : PGtkWidget; data : gpointer); cdecl;
var
   buf : pgchar;
   a_label : PGtkLabel; 
   spin : PGtkSpinButton;
begin
   spin := GTK_SPIN_BUTTON(spinner1);
   a_label := GTK_LABEL(g_object_get_data(G_OBJECT(widget), 'user_data'));
   if (GPOINTER_TO_INT(data) = 1) then
      buf := g_strdup_printf(32, '%d', gtk_spin_button_get_value_as_int(spin))
   else
      buf := g_strdup_printf(32, '%0.*f', gtk_spin_button_get_digits(spin),
                             gtk_spin_button_get_value(spin));
   gtk_label_set_text(a_label, buf);
   g_free(buf);
end;

var
   window, frame, hbox, main_vbox, vbox, vbox2 : PGtkWidget;
   spinner2, spinner, button, a_label, val_label : PGtkWidget; 
   adj : PGtkAdjustment;

begin
   { Initialise GTK }
   gtk_init(@argc, @argv);

   window := gtk_window_new(GTK_WINDOW_TOPLEVEL);

   g_signal_connect(window, 'destroy',
                    G_CALLBACK(@gtk_main_quit), nil);

   gtk_window_set_title(GTK_WINDOW(window), 'Spin Button');

   main_vbox := gtk_vbox_new (false, 5);
   gtk_container_set_border_width(GTK_CONTAINER(main_vbox), 10);
   gtk_container_add(GTK_CONTAINER(window), main_vbox);

   frame := gtk_frame_new('Not accelerated');
   gtk_box_pack_start(GTK_BOX(main_vbox), frame, true, true, 0);

   vbox := gtk_vbox_new(false, 0);
   gtk_container_set_border_width(GTK_CONTAINER(vbox), 5);
   gtk_container_add(GTK_CONTAINER(frame), vbox);

   { Day, month, year spinners }

   hbox := gtk_hbox_new(false, 0);
   gtk_box_pack_start(GTK_BOX(vbox), hbox, true, true, 5);

   vbox2 := gtk_vbox_new(false, 0);
   gtk_box_pack_start(GTK_BOX(hbox), vbox2, true, true, 5);

   a_label := gtk_label_new('Day :');
   gtk_misc_set_alignment(GTK_MISC(a_label), 0, 0.5);
   gtk_box_pack_start(GTK_BOX(vbox2), a_label, false, true, 0);

   adj := PGtkAdjustment(gtk_adjustment_new(1.0, 1.0, 31.0, 1.0, 5.0, 0.0));

   spinner := gtk_spin_button_new(adj, 0, 0);
   gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(spinner), true);
   gtk_box_pack_start(GTK_BOX(vbox2), spinner, false, true, 0);

   vbox2 := gtk_vbox_new(false, 0);
   gtk_box_pack_start(GTK_BOX (hbox), vbox2, true, true, 5);

   a_label := gtk_label_new('Month :');
   gtk_misc_set_alignment(GTK_MISC(a_label), 0, 0.5);
   gtk_box_pack_start(GTK_BOX(vbox2), a_label, false, true, 0);

   adj := PGtkAdjustment(gtk_adjustment_new(1.0, 1.0, 12.0, 1.0, 5.0, 0.0));

   spinner := gtk_spin_button_new(adj, 0, 0);
   gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(spinner), true);
   gtk_box_pack_start(GTK_BOX(vbox2), spinner, false, true, 0);

   vbox2 := gtk_vbox_new(false, 0);
   gtk_box_pack_start(GTK_BOX (hbox), vbox2, true, true, 5);

   a_label := gtk_label_new('Year :');
   gtk_misc_set_alignment(GTK_MISC(a_label), 0, 0.5);
   gtk_box_pack_start(GTK_BOX(vbox2), a_label, false, true, 0);

   adj := PGtkAdjustment(gtk_adjustment_new(1998.0, 0.0, 2100.0,
                                            1.0, 100.0, 0.0));

   spinner := gtk_spin_button_new(adj, 0, 0);
   gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spinner), false);
   gtk_widget_set_size_request(spinner, 55, -1);
   gtk_box_pack_start(GTK_BOX(vbox2), spinner, false, true, 0);

   frame := gtk_frame_new('Accelerated');
   gtk_box_pack_start(GTK_BOX(main_vbox), frame, true, true, 0);

   vbox := gtk_vbox_new(false, 0);
   gtk_container_set_border_width(GTK_CONTAINER (vbox), 5);
   gtk_container_add(GTK_CONTAINER(frame), vbox);

   hbox := gtk_hbox_new(false, 0);
   gtk_box_pack_start(GTK_BOX(vbox), hbox, false, true, 5);

   vbox2 := gtk_vbox_new(false, 0);
   gtk_box_pack_start(GTK_BOX (hbox), vbox2, true, true, 5);

   a_label := gtk_label_new ('Value :');
   gtk_misc_set_alignment (GTK_MISC (a_label), 0, 0.5);
   gtk_box_pack_start(GTK_BOX (vbox2), a_label, false, true, 0);

   adj := PGtkAdjustment(gtk_adjustment_new(0.0, -10000.0, 10000.0,
                                            0.5, 100.0, 0.0));

   spinner1 := gtk_spin_button_new(adj, 1.0, 2);
   gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(spinner1), true);
   gtk_widget_set_size_request(spinner1, 100, -1);
   gtk_box_pack_start(GTK_BOX (vbox2), spinner1, false, true, 0);

   vbox2 := gtk_vbox_new(false, 0);
   gtk_box_pack_start(GTK_BOX (hbox), vbox2, true, true, 5);

   a_label := gtk_label_new('Digits :');
   gtk_misc_set_alignment(GTK_MISC (a_label), 0, 0.5);
   gtk_box_pack_start(GTK_BOX (vbox2), a_label, false, true, 0);

   adj := PGtkAdjustment(gtk_adjustment_new(2, 1, 5, 1, 1, 0));
   spinner2 := gtk_spin_button_new(adj, 0.0, 0);
   gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(spinner2), true);
   g_signal_connect(adj, 'value_changed',
                    G_CALLBACK(@change_digits), spinner2);
   gtk_box_pack_start(GTK_BOX(vbox2), spinner2, false, true, 0);

   hbox := gtk_hbox_new(false, 0);
   gtk_box_pack_start(GTK_BOX(vbox), hbox, false, true, 5);

   button := gtk_check_button_new_with_label('Snap to 0.5-ticks');
   g_signal_connect(button, 'clicked',
                    G_CALLBACK(@toggle_snap), spinner1);
   gtk_box_pack_start(GTK_BOX(vbox), button, true, true, 0);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), true);

   button := gtk_check_button_new_with_label('Numeric only input mode');
   g_signal_connect(button, 'clicked',
                    G_CALLBACK(@toggle_numeric), spinner1);
   gtk_box_pack_start(GTK_BOX(vbox), button, true, true, 0);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), true);

   val_label := gtk_label_new ('');

   hbox := gtk_hbox_new(false, 0);
   gtk_box_pack_start(GTK_BOX(vbox), hbox, false, true, 5);
   button := gtk_button_new_with_label('Value as Int');
   g_object_set_data(G_OBJECT(button), 'user_data', val_label);
   g_signal_connect(button, 'clicked',
                    G_CALLBACK(@get_value), @a);  //!!!
   gtk_box_pack_start(GTK_BOX(hbox), button, true, true, 5);

   button := gtk_button_new_with_label('Value as Float');
   g_object_set_data(G_OBJECT(button), 'user_data', val_label);
   g_signal_connect(button, 'clicked',
                    G_CALLBACK(@get_value), @b);  //!!!
   gtk_box_pack_start(GTK_BOX(hbox), button, true, true, 5);

   gtk_box_pack_start(GTK_BOX(vbox), val_label, true, true, 0);
   gtk_label_set_text(GTK_LABEL(val_label), '0');

   hbox := gtk_hbox_new(false, 0);
   gtk_box_pack_start(GTK_BOX(main_vbox), hbox, false, true, 0);

   button := gtk_button_new_with_label('Close');
   g_signal_connect_swapped(button, 'clicked',
                            G_CALLBACK(@gtk_widget_destroy),
                            window);
   gtk_box_pack_start(GTK_BOX(hbox), button, true, true, 5);

   gtk_widget_show_all(window);

  { Enter the event loop }
  gtk_main ();
end.

{*EOF*}
