program Statusbar;

{$MODE objfpc}

uses glib2, gtk2;

var
    status_bar : PGtkWidget;
    count : integer = 1;

procedure push_item (widget : PGtkWidget; data : pgint); cdecl;
var
   buff : pgchar;
begin
   buff := g_strdup_printf('Item %d', count);
   Inc(count);
   gtk_statusbar_push(GTK_STATUSBAR(status_bar), data^, buff);
   g_free(buff);
end;

procedure pop_item (widget : PGtkWidget; data : pgint); cdecl;
begin
   gtk_statusbar_pop(GTK_STATUSBAR(status_bar), data^);
end;

var
   window, vbox, button : PGtkWidget;
   context_id : gint;

begin
   gtk_init(@argc, @argv);

   { Create a new window }
   window := gtk_window_new(GTK_WINDOW_TOPLEVEL);
   gtk_widget_set_size_request(GTK_WIDGET(window), 200, 100);
   gtk_window_set_title(GTK_WINDOW (window), 'GTK Statusbar Example');
   g_signal_connect(window, 'delete_event',
                    G_CALLBACK(@gtk_main_quit), nil);

   vbox := gtk_vbox_new(false, 1);
   gtk_container_add(GTK_CONTAINER(window), vbox);
   gtk_widget_show(vbox);

   status_bar := gtk_statusbar_new();
   gtk_box_pack_start(GTK_BOX (vbox), status_bar, true, true, 0);
   gtk_widget_show(status_bar);

   context_id := gtk_statusbar_get_context_id(GTK_STATUSBAR(status_bar),
                                              'Statusbar example');

   button := gtk_button_new_with_label('push item');
   g_signal_connect(button, 'clicked',
                    G_CALLBACK(@push_item), @context_id);
   gtk_box_pack_start(GTK_BOX(vbox), button, true, true, 2);
   gtk_widget_show(button);

   button := gtk_button_new_with_label('pop last item');
   g_signal_connect(button, 'clicked',
                    G_CALLBACK(@pop_item), @context_id);
   gtk_box_pack_start(GTK_BOX(vbox), button, true, true, 2);
   gtk_widget_show(button);

   { Always display the window as the last step so it all splashes on
     the screen at once. }
   gtk_widget_show(window);
   
   gtk_main();
end.

{*EOF*}
