unit tictactoe;

interface

uses
  glib2, gdk2, gtk2;

type
   PTictactoe = ^TTictactoe;
   TTictactoe = record
	           table : TGtkTable;
	           buttons : array [0..2 , 0..2] of PGtkWidget;
	        end;
   PTictactoeClass = ^TTictactoeClass;
   TTictactoeClass = record
		        parent_class: TGtkTableClass;
		        tictactoe : procedure (ttt : PTictactoe); cdecl;
                     end;

function tictactoe_get_type () : GType;
function tictactoe_new () : PGtkWidget;
procedure tictactoe_clear (ttt : PTictactoe);

function TICTACTOE_TYPE () : GType;
function TICTACTOE (obj : Pointer) : PTictactoe;
function TICTACTOE_CLASS (klass : pointer) : PTictactoeClass;
function IS_TICTACTOE (obj : pointer) : boolean;
function IS_TICTACTOE_CLASS (klass : pointer) : boolean;

implementation

function TICTACTOE_TYPE () : GType;
begin
   TICTACTOE_TYPE := tictactoe_get_type();
end;

function TICTACTOE (obj : pointer) : PTictactoe;
begin
   TICTACTOE := PTictactoe(G_TYPE_CHECK_INSTANCE_CAST(obj, TICTACTOE_TYPE));
end;

function TICTACTOE_CLASS (klass : pointer) : PTictactoeClass;
begin
   TICTACTOE_CLASS := PTictactoeClass(G_TYPE_CHECK_CLASS_CAST(klass, TICTACTOE_TYPE));
end;

function IS_TICTACTOE (obj : pointer) : boolean;
begin
   IS_TICTACTOE := G_TYPE_CHECK_INSTANCE_TYPE(obj, TICTACTOE_TYPE);
end;

function IS_TICTACTOE_CLASS (klass : pointer) : boolean;
begin
   IS_TICTACTOE_CLASS := G_TYPE_CHECK_CLASS_TYPE(klass, TICTACTOE_TYPE);
end;

type
  TTT_Signals = (TICTACTOE_SIGNAL);

const
   tictactoe_signals: array [TTT_Signals] of guint = (0);

procedure tictactoe_toggle (widget : pGtkWidget ; ttt: pTictactoe); cdecl;
const
   rwins: array[0..7, 0..2] of integer = 
   ((0, 0, 0), (1, 1, 1), (2, 2, 2),
    (0, 1, 2), (0, 1, 2), (0, 1, 2),
    (0, 1, 2), (0, 1, 2));
   cwins:array [0..7, 0..2] of integer =
   ((0, 1, 2), (0, 1, 2), (0, 1, 2),
    (0, 0, 0), (1, 1, 1), (2, 2, 2),
    (0, 1, 2), (2, 1, 0));
var
   i, k : integer;
   success, found : boolean;
begin
   for k := 0 to 7 do begin
      success := true;
      found := false;

      for i := 0 to 2 do begin
         success := success and
            gtk_toggle_button_get_active(pGTKTOGGLEBUTTON(ttt^.buttons[rwins[k, i],
                                                                       cwins[k, i]]));
         found := found or
            (ttt^.buttons[rwins[k, i], cwins[k, i]] = widget);
      end;

    if (success and found) then begin
       g_signal_emit(ttt, tictactoe_signals[TICTACTOE_SIGNAL], 0);
       break;
    end;
   end;
end;

procedure tictactoe_class_init (klass : PTictactoeClass); cdecl;
begin
   tictactoe_signals[TICTACTOE_SIGNAL] :=
      g_signal_new('tictactoe',
                   G_TYPE_FROM_CLASS(klass),
                   G_SIGNAL_RUN_FIRST or G_SIGNAL_ACTION,
                   //G_STRUCT_OFFSET(TTictactoeClass, tictactoe),
                   @klass^.tictactoe - pointer(klass),
                   nil, nil,
                   @g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
end;

procedure tictactoe_init (ttt : PTictactoe); cdecl;
var
   i, j : gint;
begin
   gtk_table_resize(GTK_TABLE(ttt), 3, 3);
   gtk_table_set_homogeneous(GTK_TABLE(ttt), true);

   for i := 0 to 2 do
      for j := 0 to 2 do begin
         ttt^.buttons[i][j] := gtk_toggle_button_new();
         gtk_table_attach_defaults(GTK_TABLE(ttt), ttt^.buttons[i][j],
                                   i, i + 1, j, j + 1);
         g_signal_connect(G_OBJECT(ttt^.buttons[i][j]), 'toggled',
                          G_CALLBACK(@tictactoe_toggle), ttt);
         gtk_widget_set_size_request(ttt^.buttons[i][j], 20, 20);
         gtk_widget_show(ttt^.buttons[i][j]);
      end;
end;

var
   ttt_type : GType = 0;

function tictactoe_get_type () : GType;
const
   ttt_info: TGTypeInfo = 
   (class_size: sizeof (TTictactoeClass);
    base_init: nil;    
    base_finalize: nil;
    class_init: TGClassInitFunc(@tictactoe_class_init);
    class_finalize: nil;
    class_data: nil;   
    instance_size: sizeof (TTictactoe);
    n_preallocs: 0;     
    instance_init: TGInstanceInitFunc(@tictactoe_init););
begin                   
   if (ttt_type = 0) then
      ttt_type := g_type_register_static (GTK_TYPE_TABLE,
                                          'Tictactoe',
                                          @ttt_info,
                                          0);
   
   tictactoe_get_type:= ttt_type;
end;

function tictactoe_new () : PGtkWidget;
begin
   tictactoe_new:= GTK_WIDGET(g_object_new(tictactoe_get_type(), nil));
end;

procedure tictactoe_clear (ttt :  PTictactoe);
var
   i, j : integer;
begin   
   for i := 0 to 2 do
      for j := 0 to 2 do begin
         g_signal_handlers_block_matched(G_OBJECT(ttt^.buttons[i][j]),
                                         G_SIGNAL_MATCH_DATA,
                                         0, 0, nil, nil, ttt);
         gtk_toggle_button_set_active(PGtkToggleButton(ttt^.buttons[i][j]),
                                      false);
         g_signal_handlers_unblock_matched(G_OBJECT(ttt^.buttons[i][j]),
                                           G_SIGNAL_MATCH_DATA,
                                           0, 0, nil, nil, ttt);
      end;
end;

end.
